	
####################################################################
#                  S U P R E M E   B L I T Z                       #
####################################################################
	#
	# A Supreme Risk Modification
	# Map and Scripting 
	# (C) 2007 (bigmrpoo@yahoo.com)
	#
	############################################################
	#               S U P R E M E   R I S K                    #
	############################################################
	#
	# A Supreme Commander Modification
	# Map and Scripting 
	# (C) 2007 Stephan Blecher (stephan@blecher.at)
	#
	# Use at your own risk and have lots of fun!
	#
	############################################################
####################################################################

local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')
local Factions = import('/lua/factions.lua').Factions

--scenario utilities
local Utilities = import('/lua/utilities.lua')

--interface utilities
local UIUtil = import('/lua/ui/uiutil.lua')
local gameParent = import('/lua/ui/game/gamemain.lua').GetGameParent()

local baseSizeMeters = 400
local baseVisionMult = 4
baseVisionMult = 200
local baseSizeInner = 0.8
local threadTime = 1

local players = {}

local tblGroup = nil

local platoon_types = {
	t1_squad_start = {
		time = 5,
		units = {
			{ name = 'uel0101', count = 1},--scout
			{ name = 'uel0106', count = 2 },--lab
			{ name = 'uel0201', count = 2 },--tank
		},
	},
	t1_squad = {
		time = 120,
		units = {
			{ name = 'uel0101', count = 1},--scout
			{ name = 'uel0106', count = 3 },--lab
			{ name = 'uel0201', count = 3 },--tank
			{ name = 'uel0103', count = 3 },--arty
		},
	},
	t2_squad = {
		time = 120,
		units = {
			{ name = 'uel0101', count = 1},--scout
			{ name = 'uel0106', count = 2 },--lab
			{ name = 'uel0201', count = 2 },--tank
			{ name = 'uel0202', count = 1 },--heavy tank
			{ name = 'uel0111', count = 1 },--mml
		},
	},
	
	support_start = {
		time = 60,
		units = {
			{ name = 'uel0101', count = 1 },--scout
		},
	},
	t1_support
 = {
		time = 120,
		units = {
			{ name = 'uel0101', count = 1 },--scout
			{ name = 'uel0103', count = 4 },--arty
		},
	},
	t2_support = {
		time = 120,
		units = {
			{ name = 'uel0101', count = 1 },--scout
			{ name = 'uel0111', count = 1 },--mml
			{ name = 'uel0307', count = 1 },--shield
		}
	},
	
	blitz_start = {
		time = 120,
		units = {
			{ name = 'uel0201', count = 1 },--tank
		},
	},
	t1_blitz = {
		time = 180,
		units = {
			{ name = 'uel0201', count = 5 },--tank
			{ name = 'uel0106', count = 5 },--lab
		},
	},
	t2_blitz = {
		time = 180,
		units = {
			{ name = 'uel0202', count = 5 },--heavy tank
		},
	},
	t2_defense = {
		time = 180,
		units = {
			{ name = 'uel0111', count = 3 },--mml
		--	{ name = 'uel0205', count = 1 },--aa
		},
	},
	
	t2_assault = {
		time = 240,
		units = {
			{ name = 'uel0203', count = 5 },--amphibious tank
		},
	},
	t3_assault = {
		time = 240,
		units = {
			{ name = 'uel0303', count = 4 },--sab
			{ name = 'uel0307', count = 1 },--sheild
		},
	},
	t3_long_range = {
		time = 240,
		units = {
			{ name = 'uel0304', count = 3 },--mobile arty
		},
	},
	t3_kickarse = {
		time = 300,
		units = {
			{ name = 'url0402', count = 1 },--spiderbot
		},
	},
	t3_kickarse2 = {
		time = 300,
		units = {
			{ name = 'ual0401', count = 1 },--sacred assault bot
		},
	},
}

local income_lists = {
	tac_squad = {
		platoon = platoon_types.blitz_start,
		next = 'tac_squad2',
	},
	tac_squad2 = {
		platoon = platoon_types.t1_blitz,
		count = 3,
		next = 'tac_squad3',
	},
	tac_squad3 = {
		platoon = platoon_types.t2_blitz,
		next = 'tac_squad4',
	},
	tac_squad4 = {
		platoon = platoon_types.t2_defense,
		next = 'tac_squad3',
	},
	
	support = {
		platoon = platoon_types.support_start,
		next = 'support2',
	},
	support2 = {
		platoon = platoon_types.t1_support,
		count = 4,
		next = 'support3',
	},
	support3 = {
		platoon = platoon_types.t2_support,
	},
	
	backbone = {
		platoon = platoon_types.t1_squad_start,
		count = 5,
		next = 'backbone2',
	},
	backbone2 = {
		platoon = platoon_types.t1_squad,
		count = 4,
		next = 'backbone3',
	},
	backbone3 = {
		platoon = platoon_types.t2_squad,
	},
	
	special = { next = 'special2',
		platoon = platoon_types.t2_assault,
	},
	special2 = { next = 'special3',
		platoon = platoon_types.t3_assault,
	},
	special3 = { next = 'special4',
		platoon = platoon_types.t3_long_range,
	},
	special4 = { next = 'special5',
		platoon = platoon_types.t2_assault,
	},
	special5 = { next = 'special6',
		platoon = platoon_types.t3_kickarse,
	},
	special6 = { next = 'special2',
		platoon = platoon_types.t3_kickarse2,
	},
}

local capture_points = {
	['West Base'] = 
	{	income = income_lists.backbone,
		pos = ScenarioUtils.MarkerToPosition( 'BASE_1' ),
		rally = ScenarioUtils.MarkerToPosition( 'RALLY_BASE_1' ),
	},
	['East Base'] = 
	{	income = income_lists.backbone,
		pos = ScenarioUtils.MarkerToPosition( 'BASE_2' ),
		rally = ScenarioUtils.MarkerToPosition( 'RALLY_BASE_2' ),
	},
	['West Lookout'] = 
	{	income = income_lists.tac_squad,
		pos = ScenarioUtils.MarkerToPosition( 'LOOKOUT_1' ),
		rally = ScenarioUtils.MarkerToPosition( 'RALLY_LOOKOUT_1' ),
	},
	['East Lookout'] = 
	{	income = income_lists.tac_squad,
		pos = ScenarioUtils.MarkerToPosition( 'LOOKOUT_2' ),
		rally = ScenarioUtils.MarkerToPosition( 'RALLY_LOOKOUT_2' ),
	},
	['West Headland'] = 
	{	income = income_lists.tac_squad,
		pos = ScenarioUtils.MarkerToPosition( 'HEADLAND_1' ),
		rally = ScenarioUtils.MarkerToPosition( 'RALLY_HEADLAND_1' ),
	},
	['East Headland'] = 
	{	income = income_lists.tac_squad,
		pos = ScenarioUtils.MarkerToPosition( 'HEADLAND_2' ),
		rally = ScenarioUtils.MarkerToPosition( 'RALLY_HEADLAND_2' ),
	},
	['Center North'] = 
	{	income = income_lists.backbone,
		pos = ScenarioUtils.MarkerToPosition( 'CENTER_N' ),
		rally = ScenarioUtils.MarkerToPosition( 'RALLY_CENTER_1' ),
	},
	['Center West'] = 
	{	income = income_lists.backbone,
		pos = ScenarioUtils.MarkerToPosition( 'CENTER_W' ),
		rally = ScenarioUtils.MarkerToPosition( 'RALLY_CENTER_1' ),
	},
	['Center South'] = 
	{	income = income_lists.backbone,
		pos = ScenarioUtils.MarkerToPosition( 'CENTER_S' ),
		rally = ScenarioUtils.MarkerToPosition( 'RALLY_CENTER_2' ),
	},
	['Center East'] = 
	{	income = income_lists.backbone,
		pos = ScenarioUtils.MarkerToPosition( 'CENTER_E' ),
		rally = ScenarioUtils.MarkerToPosition( 'RALLY_CENTER_2' ),
	},
	['Center'] = 
	{	income = income_lists.special,
		pos = ScenarioUtils.MarkerToPosition( 'CENTER' ),
	},
}
local num_cap_points = 0
for name,cap_point in capture_points do
	num_cap_points = num_cap_points + 1
end

local spawn_points = {
	['ARMY_1'] = {
		base = {
			capture_points['West Base']
		},
		unit = {
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_1' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_2' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_3' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_4' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_5' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_6' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_7' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_8' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_9' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_10' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_11' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_12' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_1_13' ),
		},
	},
	['ARMY_2'] = {
		base = {
			capture_points['East Base']
		},
		unit = {
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_1' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_2' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_3' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_4' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_5' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_6' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_7' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_8' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_9' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_10' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_11' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_12' ),
			ScenarioUtils.MarkerToPosition( 'SPAWN_2_13' ),
		},
	},
}

local to_be_created = {}
local just_was_created = {}
function do_the_create()
	just_was_created = CreateUnitHPR(to_be_created.name, to_be_created.owner, to_be_created.pos[1],to_be_created.pos[2],to_be_created.pos[3], 0,0,0)
end
function CreateUnitSafe( name, owner, pos )
	to_be_created.name = name
	to_be_created.owner = owner
	to_be_created.pos = pos
	pcall(do_the_create) 
	return just_was_created;
end

  
local player = nil;

    function basicSerialize (o)
      if type(o) == "number" then
        return tostring(o)
      else   -- assume it is a string
        return string.format("%q", o)
      end
    end

    function Xsave (name, value, saved)
	  local str = ""
      saved = saved or {}       -- initial value
      str = str..name.." = "
      if type(value) == "number" or type(value) == "string" then
        str = str..basicSerialize(value).."\n"
      elseif type(value) == "table" then
        if saved[value] then    -- value already saved?
          str = str..saved[value].."\n"  -- use its previous name
        else
          saved[value] = name   -- save name for next time
          str = str.."{}\n"     -- create a new table
          for k,v in value do      -- save its fields
            local fieldname = string.format("%s[%s]", name,
                                            basicSerialize(k))
            str = str..Xsave(fieldname, v, saved)
          end
        end
      else
        --error("cannot save a " .. type(value))
      end
	  return str
    end

	
function dump(tbl)
	LOG(Xsave("var",tbl,nil))
end

function meter(m)
	return m*0.0512
end

function Pos(x,y,z)
	if z == nil then z = 128 end
	local p = {}
	p[1] = x
	p[3] = y
	p[2] = z
	return p
end
  
function zoomOut()
	-- Set Camera to show full Map
	local Camera = import('/lua/SimCamera.lua').SimCamera
	local cam = Camera("WorldCamera")
	--  cam:MoveTo(ScenarioUtils.AreaToRect('AREA_1'))
	cam:SetZoom(2000,0)
end

function numPlayers()
	return table.getn(players)
end

################################
################################
################################


function OnPopulate()
	tblGroup = ScenarioUtils.InitializeArmies()
--	ScenarioFramework.SetPlayableArea('AREA_1' , false)
	zoomOut()
end


################################
############ init ##############
################################
function initMainThread()
	ForkThread(mainThread)
	ForkThread(jobsThread)
end

function mainThread()
	while true do
		checkCapPointOwnership()
		
		checkReinforcements()
		checkEndOfGame()
		
		updateAI() --todo - move to own thread?
		
		WaitSeconds(threadTime)
	end
end

function jobsThread()
	while true do
		reassignFlags()
		WaitSeconds(threadTime)
	end
end

function OnStart(self)
  LOG("OnStart -------------------------------")

  init()
  initPlayers() 
  initCapturePointOwnership()
  --initStartUnits() -- putting up units and countries
  
  initAI()
  
  checkCapPointOwnership() 

  initMainThread()
end

function init()
	for index,army in ListArmies() do
		LOG(index.." "..army.." is playing")
		
		#Building Restrictions
		ScenarioFramework.AddRestriction(index, categories.STRUCTURE)
	end
	
end

-- distribute cap points among players
function initCapturePointOwnership()
	--copy index into a variable...
	for index,cap_point in capture_points do
		cap_point.name = index
	end
	
	for army,spawn in spawn_points do
		local bases = spawn.base
		for i,base in bases do
			spawnCapturePoint(base, army)
		end	
	end
end




function initPlayers()
	-- ACU and Resources
	local playerACUs = GetUnitsInRect(Rect(0,0,512,512))--TODO get map size like levirus showed me
	for i,acu in playerACUs do
		if EntityCategoryContains( categories.uel0001 + categories.ual0001 + categories.url0001, acu ) then
			LOG("found ACU "..acu:GetArmy())
		
			local player = {};
			player.index = acu:GetArmy();
			player.acu = acu;
			
			player.acu.player = player;
			
			player.armyName = getArmyName(player.acu);
			players[acu:GetArmy()] = player;
	
			-- enhancement stuff (disable all of them!)
	        AddUnitEnhancement(player.acu,'dummy', 'Back')	
	        AddUnitEnhancement(player.acu,'dummy', 'RCH')	
	        AddUnitEnhancement(player.acu,'dummy', 'LCH')	
			player.acu:RequestRefreshUI()
	  		
			-- mobility
			player.acu:SetImmobile(true)
	
			--brain
			player.brain = GetArmyBrain(player.armyName)
		--	player.brain.player = player -- callback ( useful for coding an AI later)
			player.brain.CalculateScore = function(self)
				return player.empireSize
			end
			
			player.empireSize = 0;
		end
	end
end

function GetFaction(player)
	return Factions[GetArmyBrain(player.armyName):GetFactionIndex()]
end


function spawnCapturePoint(cdata,army)
	cdata.owner = army
	cdata.flagOwnershipChanged = true
end
					
function spawnFlag(cdata)
	if cdata.owner == nil then
	else
		local x = cdata.pos[1]
		local y = cdata.pos[2]
		local z = cdata.pos[3]
		local name = cdata.name
		local u = CreateUnitSafe( 'ueb1102', cdata.owner, {x,y,z})
	
		u.CreateWreckage = function() end
	
		u:SetAllWeaponsEnabled(false)		
		u:SetCanBeKilled(true)
		u:SetIsValidTarget(false)
		u:SetDoNotTarget(true)
		u:SetMaxHealth(1)
		u:SetHealth(nil,1)
		u:SetRegenRate(1)
		u:SetIntelRadius('Vision', meter(baseSizeMeters*baseVisionMult))
		u:SetCustomName(name)
		
	--	LOG( 'SPAWNED FLAG for army = '..cdata.owner )
		cdata.flag = u
		cdata.flagOwnershipChanged = false
	end
end

function initUnit(unit)
--[[
	unit:AddOnKilledCallback(
		function(self) 
			LOG("Unit died")
		end					)
]]--
end

function round(num)
	return math.floor(num + 0.5)
end

function getArmyName(unit)
	local unitArmy = unit
	if unit.GetArmy then
		unitArmy = unit:GetArmy()
	end
	
	return ListArmies()[unitArmy]
end

--[[
function presidentIsAlive(cap_point)
	if cap_point.president == nil or cap_point.president:IsDead() == true then
		return false
	else
		return true
	end
end

function setAsPresident(cap_point, unit)

	local x = cap_point.pos[1]-3
	local y = cap_point.pos[2]
	local z = cap_point.pos[3]+5
	if not unit then
		unit = CreateUnitSafe('uel0106', cap_point.owner, {x,y,z})
		unit.isInitialPresident = true;
		initUnit(unit)		
	end

	-- only alive units can be elected president
	if not unit:IsBeingBuilt() and not unit:IsDead() then
		LOG(cap_point.name.." elected a new president")
		cap_point.president = unit
	--	unit:SetCustomName("President of "..cap_point.name)
		unit.isPresident = true

		-- stop unit from moving
	--	unit:SetImmobile(true)
	--	unit:SetUnSelectable(true)
	end
end
]]--


function checkCapPointOwnership()	
	for i, player in players do
		player.empireSize = 0
	end
	
	for ci,cdata in capture_points do
		rect = {x0 = cdata.pos[1] - meter(baseSizeMeters)*baseSizeInner,
				x1 = cdata.pos[1] + meter(baseSizeMeters)*baseSizeInner,
				y0 = cdata.pos[3] - meter(baseSizeMeters)*baseSizeInner,
				y1 = cdata.pos[3] + meter(baseSizeMeters)*baseSizeInner
				}
				
		local units = GetUnitsInRect(rect)
		
		local armycounters = {}
		if units then
			for index,unit in units do
				if not unit:IsDead() and not unit:IsBeingBuilt() and unit:GetWeaponCount() > 0 then
								
					if(armycounters[unit:GetArmy()]) then
						armycounters[unit:GetArmy()] = armycounters[unit:GetArmy()] +1
					else
						armycounters[unit:GetArmy()] = 1;
					end
					--[[
					if(getArmyName(unit) == cdata.owner) then
						-- own unit					
						--if cdata.president != unit then
							--unit:SetCustomName("") --Citizen of "..cdata.name)
						--end
						if not presidentIsAlive(cdata) then
							setAsPresident(cdata, unit)
						end
					end
					]]--
				end
			end
		end
		local enemyUnits = 0;
		local enemyArmy = nil;
		local enemyArmyId = nil;
		local friendlyUnits = 0;
		for index, counter in armycounters do
			--LOG("player "..index.." "..getArmyName(index)..": "..counter.." found in "..cdata.name.." ("..cdata.owner..")");
			if getArmyName(index) == cdata.owner then
				friendlyUnits = counter
				cdata.friendlyUnits = friendlyUnits
			else
				enemyUnits = enemyUnits +counter
				enemyArmy = getArmyName(index)
				enemyArmyId = index
			end
	    end
		if enemyUnits > 0 then
			-- kill flag
			if cdata.flag then
				cdata.flag:SetCanBeKilled(true)
				cdata.flag:Kill()
				cdata.flag=nil
			end
			cdata.isAttacked = true
		else
			if cdata.income_spawn_time == nil then
			setFlagName(cdata,cdata.name)
			else
			setFlagName(cdata,cdata.name..": "..cdata.income_spawn_time)
			end
		--	setFlagName(cdata,cdata.name..": "..friendlyUnits)
			cdata.isAttacked = false
		end

		if friendlyUnits == 0 and enemyUnits > 0 then
			LOG(cdata.name.." liberated by "..enemyArmy)
			cdata.owner = enemyArmy				
			cdata.flagOwnershipChanged = true;
		end
		
		--[[
		if friendlyUnits == 0 and enemyUnits == 0 and cdata.owner != nil then
			LOG( 'cdata.owner being set to nil!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!' )
			cdata.owner = nil
			cdata.flagOwnershipChanged = true;
		end
		]]--
				
		-- update Empire Size
		for i, player in players do
			if player.armyName == cdata.owner then
				player.empireSize = player.empireSize +1
			end
		end
	end

end

function setFlagName(cap_point, text)
	if cap_point.flag != nil and not cap_point.flag:IsDead() then
		cap_point.flag:SetCustomName(text)
	end
end

function respawnFlag(c)
	if c.flag != nil then
		local f = c.flag
		c.flag = nil;
		f:SetCanBeKilled(true)
		if not f:IsDead() then f:Kill() end
		WaitSeconds(2)
	end
	
	WaitSeconds(2)
	if not c.isAttacked and c.flag == nil then -- only respawn if not being attacked
		if c.owner == nil then
		else
		--	LOG("SPAWNING FLAG for "..c.owner)
			spawnFlag(c)
		end
	end
end

function reassignFlags()
	for i,c in capture_points do
		if c.flagOwnershipChanged == true or c.flagOwnershipChanged == nil or (c.flag and c.flag:IsDead()) or not c.flag then
			ForkThread(respawnFlag,c)
		end
	end
end

local nextSpawnPointID = {}
function getSpawnPoint( owner )
	if nextSpawnPointID[owner] == nil then
		nextSpawnPointID[owner] = 1
	end

	markers = spawn_points[owner].unit
	local numMarkers = table.getn(markers)
	local point = markers[nextSpawnPointID[owner]]
	
	nextSpawnPointID[owner] = nextSpawnPointID[owner] + 1
	if nextSpawnPointID[owner] > numMarkers  then
		nextSpawnPointID[owner] = 1
	end
	
	return point
end

function spawnPlatoon( platoon, owner )
	--TODO - check unit cap first!
	local group_index = 1
	local group = {}
	if platoon.units == nil then
		LOG( 'spawning nil platoon!!!!!' )
	else
		for i,unit in platoon.units do
			local pos = getSpawnPoint( owner )
			local ii = 1
			while ii <= unit.count do
				local u = CreateUnitSafe(unit.name, owner, pos)
				initUnit(u)
				group[group_index] = u
				group_index = group_index+1
				ii = ii+1
			end
		end
	end
	addAIUnitGroup( owner, group ) -- notify the AI
	return group
end

##########################################
# Round Functions
##########################################

--[[
function displayRoundCountdown(staytime)
	local ileft = maxRoundIdleTime - roundIdleSeconds
	PrintText("Next Round will start in "..ileft.." seconds",20,'FFFFFFFF',staytime,'centerbottom') 
	WaitTicks(3)
end
]]--

function checkReinforcements() 
	for i,cap_point in capture_points do
		if cap_point.owner == nil or cap_point.income == nil or cap_point.income.platoon == nil then
		else
			if cap_point.income_spawn_time == nil then
				if cap_point.income.platoon.time == nil then
					LOG( '!!!!!!!!!!!'..i )
				--	dump( cap_point )
					cap_point.income_spawn_time = 60
				else
					cap_point.income_spawn_time = cap_point.income.platoon.time
				end
			end
			cap_point.income_spawn_time = cap_point.income_spawn_time - threadTime
			
			--LOG("cap_point.income_spawn_time = "..cap_point.income_spawn_time)
			
			if cap_point.income_spawn_time <= 0 then
				local reserved = 0
				local armyIndex = GetArmyBrain(cap_point.owner):GetArmyIndex()
				local unitCount = GetArmyUnitCostTotal(armyIndex)
				local unitLimit = GetArmyUnitCap(armyIndex) - reserved
				local platCount = GetPlatoonCapCost( cap_point.income.platoon )
				
				if (unitCount+platCount) < unitLimit then
					cap_point.income_spawn_time = nil
					LOG("Reinforcements have arrived!")
					PrintText("Reinforcements have arrived!",20,'FFFFFFFF',3,'centerbottom') 
					
					local group = spawnPlatoon( cap_point.income.platoon, cap_point.owner )
					local offs1 = math.random(5)
					local offs2 = math.random(5)
					local pos = { cap_point.pos[1]+offs1-offs2, cap_point.pos[2], cap_point.pos[3]-offs1+offs2 }
					IssueMove( group, cap_point.rally or pos )
					
					if cap_point.income.next == nil then
					else
						local count = cap_point.income.count or 1
						if cap_point.income_count_currently == nil then
							cap_point.income_count_currently = 1
						else
							cap_point.income_count_currently = cap_point.income_count_currently + 1
						end
						if cap_point.income_count_currently >= count then
							cap_point.income_count_currently = nil
							cap_point.income = income_lists[cap_point.income.next]
						end
					end
				else
					cap_point.income_spawn_time = 0 -- keep trying
				end
			end
		end
	end
end

function GetPlatoonCapCost( platoon )
	local count = 0
	for i,group in platoon.units do
		count = count + group.count
	end
	return count
end

function checkPlayerDeath(player)
--TODO - dont kill instantly, give a countdown instead...
	if player.empireSize == 0 then
		if not player.acu:IsDead() then 
			player.acu:Kill() -- goodbye ACU
		end
	end
end

function checkPlayerWin(player)
--TODO - check if player.acu is the only acu left alive
end

function checkEndOfGame()
	for i, player in players do
		checkPlayerDeath(player)
		checkPlayerWin(player)
	end
end

function isInside(zone, pos)
	if  pos[1] <= zone.x1 and pos[1] >= zone.x0 
	and pos[3] <= zone.y1 and pos[3] >= zone.y0 then
		return true
	else
		return false
	end
end

function Pos2Rect(pos, radius)
	return Rect(pos[1]-radius, pos[3]-radius, pos[1]+radius, pos[3]+radius)
end






--[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
############  AI  ##############
]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]--

local AIBlackBoard = {}
function initAI()	
	for army,spawn in spawn_points do
		local brain = GetArmyBrain(army)
		if brain.BrainType == 'Human' then
			AIBlackBoard[army] = nil
		else
			AIBlackBoard[army] = {
				capture_points = {},
				goal_locations = {}
			}
			for index,cap_point in capture_points do
				AIBlackBoard[army].goal_locations[index] = {
					objective = capture_points[index],
					likely_enemy = 0,
				}
			end
			
			AIBlackBoard[army].next_group_id = 1
			AIBlackBoard[army].groups = {}
		end
	end
	
	updateInfluenceMap()
end

function addAIUnitGroup( army, units )
	if AIBlackBoard[army] == nil then else
		if units == nil then
			LOG( 'WTF u go adding empty unit group for?' )
		else
			LOG( 'adding group to army '..army )
			local id = AIBlackBoard[army].next_group_id
			AIBlackBoard[army].next_group_id = id + 1
			local group = {}
			group.id = id
			group.units = units
			AIBlackBoard[army].groups[id] = group
			return group
		end
	end
end

function updateAI()
	for army,blackBoard in AIBlackBoard do
		if blackBoard.plan == nil then
			blackBoard.plan = {}
			blackBoard.plan.Update = wakeUp --regain conciousness
		end
		if blackBoard.plan.Info == nil then blackBoard.plan.Info = {} end --blank slate
		
		updatePlannerGroup( army, blackBoard )
		
		for i,group in blackBoard.groups do
			if unitsAliveInGroup( group ) > 0 then
				updatePlannerGroup( army, group )
			else
				blackBoard.groups[i] = nil
			end
		end
	end
end

--[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
##########  AI  Utilities ###########
]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]--

function updateInfluenceMap()
	local allUnits = GetUnitsInRect(Rect(0,0,512,512))--TODO get map size like levirus showed me
	local defense = {}
	local buildings = {}
	for i,unit in allUnits do
		if EntityCategoryContains( categories.STRUCTURE, unit ) then
			if EntityCategoryContains( categories.DEFENSE, unit ) then
				table.insert( defense, unit )
			else
				table.insert( buildings, unit )
			end
		end
	end
	
	for index,cap_point in capture_points do
		--initialise ai data for each capture point
		if cap_point.ai == nil then
			cap_point.ai = {}
			--check min distance from cap_point to each spawn
			local closestDist = 999999
			local closestArmy = ''
			for army,spawn in spawn_points do
				for i,base in spawn.base do
					local dist = Utilities.GetDistanceBetweenTwoVectors(base.pos, cap_point.pos)
					if dist < closestDist then
						closestDist = dist
						closestArmy = army
					end
				end	
			end
			cap_point.ai.closestSpawnArmy = closestArmy
		end
		for i,unit in defense do
			local dist = Utilities.GetDistanceBetweenTwoVectors(unit:GetPosition(), cap_point.pos)
			if unit.cap_point_dist == nil or dist < unit.cap_point_dist then
				unit.cap_point_dist = dist
				unit.cap_point = cap_point
			end
		end
		cap_point.ai.defense = {}
		for i,unit in buildings do
			local dist = Utilities.GetDistanceBetweenTwoVectors(unit:GetPosition(), cap_point.pos)
			if unit.cap_point_dist == nil or dist < unit.cap_point_dist then
				unit.cap_point_dist = dist
				unit.cap_point = cap_point
			end
		end
		cap_point.ai.buildings = {}
	end
	for i,unit in defense do
		table.insert( unit.cap_point.ai.defense, unit )
	end
	for i,unit in buildings do
		table.insert( unit.cap_point.ai.buildings, unit )
	end
end

function updatePlannerGroup( army, group )
	-- catch any bludgers
	if group.plan == nil then
		group.plan = {}
	end
	if group.plan.Update == nil then
		group.plan.Update = reportIn
		group.plan.Info = {}
	end
	-- tell them to think
	local whatsThePlan = group.plan.Update( army, group )
	if whatsThePlan == true then
	else
		LOG( 'Plan\'s a changin\'!' )
		group.plan.Update = whatsThePlan
	end
end

function unitsAliveInGroup( group )
	local alive = 0
	for i, unit in group.units do
		if unit:IsDead() == true then
			group.units[i] = nil
		else
			alive = alive + i
		end
	end
	return alive
end



local to_be_moved = {}
function do_the_move()
	IssueMove( to_be_moved.units, to_be_moved.point )
end
function IssueMoveSafe( units, point )
	to_be_moved.units = units
	to_be_moved.point = point
	pcall(do_the_move) 
end

local to_be_cleared = {}
function do_the_clear()
	IssueClearCommands( to_be_cleared.units )
end
function IssueClearCommandsSafe( units )
	to_be_cleared.units = units
	pcall(do_the_clear) 
end

function issueMovePoint( units, point )
--	IssueAggressiveMove( units, point )
	if units == nil then
		LOG( 'wtf?eh!' )
	else
		IssueClearCommandsSafe( units )
		if table.getn(units)>0 then 
			IssueMoveSafe( units, point )
		else
			local ii = 0
			for i,unit in units do ii = ii + 1 end
			LOG( 'table.getn(units) = '..table.getn(units) )
			LOG( 'MyCount(units) = '..ii )
			LOG( 'wtf????!' )
		--	dump( units )
		end
	end
end

--[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
###########  AI  Brains ############
]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]--

local playBook = {
	quickExpansion = {
		Goals = function( army, brain )
			--capture all points closest to this army
			local goals = {}
			for index,cap_point in capture_points do
				if cap_point.owner == army then
				else
					if cap_point.ai.closestSpawnArmy == army then
						table.insert( goals, cap_point )
					end
				end
			end
			return goals;
		end,
		
		Requirements = function( army, brain, goals )
			local numGoals = table.getn( goals )
			--local numSquads = math.random( numGoals )
			local req = {
				{ units = 
						{ {category = categories.MOBILE, count = 1}
						},
				  count = numGoals, },
			}
			return req, nil;
		end,
		
		Update = function( army, brain, data )
			--check goals are still valid
			local activeGoals = 0
			for index,cap_point in data.goals do
				if cap_point.owner == army then
					--goal complete
					table.remove( data.goals, index )
				--	data.goals[index] = nil
				else
					activeGoals = activeGoals + 1
				end
			end
			if activeGoals == 0 then
				LOG( 'ran out of goals' )
				return false
			end
			--check there's still enough resources 
			--tell groups in this plan to move to places
			local numGroups = 0
			for i,group in data.groups do
				if unitsAliveInGroup(group) > 0 then
					numGroups = numGroups+1
					--if group doesnt have an attack plan, give it one
					if group.play == 'quickExpansion' and group.plan.Update == capturePoint then
					else
						group.play = 'quickExpansion'
						local nextPointID = math.random(num_cap_points);
						local nextPointID = data.nextPointID
						if nextPointID == nil or data.goals[nextPointID] == nil then
							nextPointID = 1
						end
						data.nextPointID = nextPointID + 1
						local point = data.goals[nextPointID]
						if point == nil then 
						else
							if group.plan == nil then group.plan = {} end
							if group.plan.Info == nil then group.plan.Info = {} end
							group.plan.Info.target_point = point
							group.plan.Update = capturePoint
						end
					end
				end
			end
			if numGroups == 0 then
				LOG( 'ran out of groups' )
				return false
			end
			return true
		end,
	},
}

--TODO!!!
function guessBenefit( army, goals )
	return table.getn( goals )
end
function guessCost( army, requirements )
	return table.getn( requirements )
end

function wakeUp( army, brain )
	if brain.groups == nil then
		LOG( 'Don\'t let individuals be sentient' )
		return nil
	else
		brain.plan.Update = commandAndControl
		--should do a check here for the game-type/map and load the right play book...
	end
	return true
end
		
function commandAndControl( army, brain )
	if brain.plays == nil then
		brain.plays = {}
	end
	--look through the play-book
	local bestPlayIndex = 0
	local bestPlayGain = 0
	local bestPlayGroups = {}
	local bestPlayGoals = {}
	for i,play in playBook do
		if brain.plays[play] == nil then
			--find a play, and the goals it should acheive
			local goals = play.Goals( army, brain )
			local benefit = guessBenefit( army, goals )
			if benefit > 0 then
				--calculate some requirements
				local newGoals = nil
				local req = {}
				req, newGoals = play.Requirements( army, brain, goals )
				if newGoals == nil then else
					goals = newGoals
					benefit = guessBenefit( army, goals )
				end
				local cost = guessCost( army, req )
				--compare benefit of goals to size of the requirements
				if benefit > cost then --recklessness/ignorance can be added here
					local net_gain = benefit - cost
					if net_gain > bestPlayGain then --randomness here?
						local canBeDone = true--false
						local req_groups = {}
						--look over brain.groups to see if the requirements can actually be met
							--some groups may need to be removed from an existing plan.
							--check if the existing plan's goals are more relevant to winning than the newly choses goal
							--if so, the old plan may have to be canceled
						for ii, group_desc in req do
							local req_group_count = 0
							for iii, group in brain.groups do
								for iv, unit_desc in group_desc.units do
									local req_unit_count = 0
									for v, unit in group.units do
										if unit == nil or unit:IsDead() then
											group.units[v] = nil
										else
											if unit_desc.category == nil then
												LOG( 'NIL unit_desc.category!!1' );
												LOG( 'iv = ' );
												dump(iv);
												LOG( 'unit_desc= ' );
												dump(unit_desc);
												unit_desc.category = categories.MOBILE;
											end
											if EntityCategoryContains( unit_desc.category, unit ) then
												req_unit_count = req_unit_count + 1
											end
										end
									end
									if req_unit_count >= unit_desc.count then
										table.insert( req_groups, group )
										req_group_count = req_group_count + 1
									end
								end
								if req_group_count >= group_desc.count then
									break
								end
							end
							if req_group_count < group_desc.count then
								canBeDone = false
								LOG( 'Cant be done captain!!' )
								break
							end
						end
						
						if canBeDone == true then
							bestPlayGain = net_gain
							bestPlayIndex = i
							bestPlayGroups = req_groups
							bestPlayGoals = goals
						--else 
						--	dont try again for a little bit?
						end
					end
				end
			end
		end
	end
	--if a suitable play was found, add it to the list
	if bestPlayIndex > 0 then
		local play = playBook[bestPlayIndex]
		if brain.plays[play] == nil then
			brain.plays[play] = { groups = bestPlayGroups, goals = bestPlayGoals }
			LOG( '!starting new play '..bestPlayIndex..' with '..table.getn(bestPlayGroups)..' groups' )
		else
			LOG( 'why\'d u try to reallocate a plan, fool!' )
		end
	end
	--update any plays in progress
	for play,data in brain.plays do
		if play.Update( army, brain, data ) == false then
			LOG( '!finished  play' )
		--	table.remove( brain.plays, play )
			brain.plays[play] = nil
		end
	end
	return true
end

--[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
#######  AI  Plan check functions #######
]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]--

function noEnemies( group )
	return true
end

function groupAtTarget( group )
--group.plan.Info.target
	if group.plan.Info.issued == nil then
		return false
	else
		return true
	end
--	return math.random(2)-1
end


--[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
###########  AI  Plans ############
]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]--

function capturePoint( army, group )
	if group.units == nil then
		LOG( 'WTF, no units!' )
	--	dump( group )
		return nil
	elseif group.plan.Info.target_point == nil then 
		LOG( 'WTF, no target!' )
	--	group.plan.Update = reportIn( army, group )
--	elseif groupAtTarget( group ) == true then
		return nil
	elseif group.plan.Info.target_point.owner == army then
		LOG( 'point capture plan completed' )
		return nil --done! regroup at point now?
	else
		if group.plan.Info.orders == nil then
			group.plan.Info.orders = 0 
		else
			if group.plan.Info.orders > 0 then
			else
				group.plan.Info.orders = group.plan.Info.orders + 1
				issueMovePoint( group.units, group.plan.Info.target_point.pos )
				group.plan.Info.issued = true
			end
		end
	end
	return true
end

function reportIn( army, group )
-- --[[
	if group.units == nil then
		LOG( 'Group with no units is trying to report in!' )
	end
	local firstUnit = {}
	for i,u in group.units do
		firstUnit = u
	break end
	local myPos = firstUnit:GetPosition()
--	local randomPointID = math.random(num_cap_points);
	local point = {}
--	local ii = 1
	local bestD = 999999
	local bestP = false
	for name,cap_point in capture_points do
--		if ii == randomPointID then
--			point = cap_point
--		end
--		ii = ii + 1
		if cap_point.owner == army then else
			local dist = Utilities.GetDistanceBetweenTwoVectors( cap_point.pos, myPos )
			if dist < bestD then
				bestD = dist
				bestP = cap_point
			end
		end
	end
	if bestP == false then else
		point = bestP
	end
	if point == nil then 
	else
		group.plan.Info.target_point = point
		group.plan.Update = capturePoint
	end
--	]]--
	return true
end



